--[[
	Idea taken from Mecaire's Macrotexter & hypehuman's Macrotexter.
		http://www.wowinterface.com/downloads/info6909-MecairesMacrotexter.html
		http://www.wowinterface.com/downloads/info12425-Macrotexter.html
	
	watch SKILL_LINES_CHANGED
]]

local folder, core = ...
_MA = core --needs to be made global

--[===[@debug@
--@end-debug@]===]

local _G = _G
local LibStub = LibStub
local InterfaceOptionsFrame_OpenToCategory = InterfaceOptionsFrame_OpenToCategory
local pairs = pairs
local tostring = tostring
local table_getn = table.getn
local chatFrame = _G["ChatFrame1"]
local NUM_ACTIONBAR_PAGES = NUM_ACTIONBAR_PAGES
local NUM_ACTIONBAR_BUTTONS = NUM_ACTIONBAR_BUTTONS
local GetActionInfo = GetActionInfo
local GetSpellName = GetSpellName
local BOOKTYPE_SPELL = BOOKTYPE_SPELL
local GetSpellDetails = GetSpellDetails
local GetSpellInfo = GetSpellInfo
local IsHelpfulSpell = IsHelpfulSpell
local GetMacroBody = GetMacroBody
local GetMouseFocus = GetMouseFocus
local IsHarmfulSpell = IsHarmfulSpell
local SecureCmdOptionParse = SecureCmdOptionParse
local GetCursorInfo = GetCursorInfo
local InCombatLockdown = InCombatLockdown
local print = print
local getglobal = getglobal
local PickupAction = PickupAction
local SecureHandlerSetFrameRef = SecureHandlerSetFrameRef
local SecureHandlerWrapScript = SecureHandlerWrapScript
local hooksecurefunc = hooksecurefunc
local GetItemInfo = GetItemInfo
local _ --
local assert = assert
local loadstring = loadstring
local ipairs = ipairs
local GetActionBarPage = GetActionBarPage
local SpellHasRange = SpellHasRange
local IsPassiveSpell = IsPassiveSpell
local GetNumPartyMembers = GetNumPartyMembers
local UnitGroupRolesAssigned = UnitGroupRolesAssigned
local UnitExists = UnitExists


core.title		= "Macro Actions"
core.version	= GetAddOnMetadata(folder, "X-Curse-Packaged-Version") or ""
core.titleFull	= core.title.." "..core.version
core.addonDir = "Interface\\AddOns\\"..folder.."\\"

LibStub("AceAddon-3.0"):NewAddon(core, folder, "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0", "AceTimer-3.0") 

local MA_headerFrame = CreateFrame("CheckButton", "MA_headerFrame", UIParent, "SecureActionButtonTemplate")

core.L = LibStub("AceLocale-3.0"):GetLocale(folder, true)
local L = core.L

local P --db.profile
core.initialized = false

core.defaultSettings = {
	profile = {
		macroText = {
			["Passive"]				= "/cast SPELLN", --No special targeting.
		
			["Beneficial"]			= "/cast [mod:SELFCAST, @player] [mod:shift, @mouseover] [help] [@targettarget, help] [@player] SPELLN", --[@none] 
			["Harmful"]				= "/cast [harm, nodead] [@targettarget, harm, nodead] SPELLN", --[@none] 

			["Harmful-RD"]			= "/cast [harm, nodead] [@targettarget, harm, nodead] [@TANKIDtarget, harm, nodead] SPELLN", --[@none] 
			
--~ 			["Focus Crowd Control"]	= "/focus [btn:2] target\n/cast [btn:3] [@focus, exists] [] SPELLN",
		},
		macroTextDesc = {
			["Passive"]				= "No special casting.",
		
			["Beneficial"]			= "Healing/buff spells",
			["Harmful"]				= "Attack spells",
			["Harmful-RD"] 			= "Attack spells in random dungeon",
		},
		
	},
}



local regEvents = {
	"ACTIONBAR_SLOT_CHANGED",
	"SKILL_LINES_CHANGED",
--~ 	"PLAYER_REGEN_ENABLED",
	"PLAYER_ENTERING_WORLD",
	"PARTY_MEMBERS_CHANGED",
	"ACTIVE_TALENT_GROUP_CHANGED",
}
local coreOpts

function core:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("MA_DB", core.defaultSettings)
	self.CoreOptionsTable.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileDeleted", "OnProfileChanged")
	self:RegisterChatCommand("macroactions", "MySlashProcessorFunc")
	
	chatFrame = _G["ChatFrame1"]
	
	local config = LibStub("AceConfig-3.0")
	local dialog = LibStub("AceConfigDialog-3.0")
	config:RegisterOptionsTable(folder, self.CoreOptionsTable)
	coreOpts = dialog:AddToBlizOptions(folder, self.titleFull)
	
	hooksecurefunc("PickupAction", core.InsecurelyUpdateAction)
	hooksecurefunc("PlaceAction", core.InsecurelyUpdateAction)
end



----------------------------------------------------------------------
function core:OnProfileChanged(...)									--
-- User has reset proflie, so we reset our spell exists options.	--
----------------------------------------------------------------------
	-- Shut down anything left from previous settings
	self:Disable()
	-- Enable again with the new settings
	self:Enable()
end

function core:OnEnable()
	P = self.db.profile

	for i, event in pairs(regEvents) do 
		self:RegisterEvent(event)
	end
	
	if not self.initialized then
		self:WorkTheBars()
	end
end



function core:OnDisable()
--~ 	timerFrame:SetScript("OnUpdate", nil)
end


local DEBUG = false
--[===[@debug@
DEBUG = true
--@end-debug@]===]

local strWhiteBar		= "|cffffff00 || |r" -- a white bar to seperate the debug info.
local colouredName		= "|cff7f7f7f{|r|cffff0000MA|r|cff7f7f7f}|r "
local function echo(...)
	local tbl  = {...}
	local msg = tostring(tbl[1])
	for i=2,table_getn(tbl) do 
		msg = msg..strWhiteBar..tostring(tbl[i])
	end
	
	local cf = chatFrame
	if cf then
		cf:AddMessage(colouredName..msg,.7,.7,.7)
	end
end
core.echo = echo

--~ local whiteText			= "|cffffffff%s|r"
local strDebugFrom		= "|cffffff00[%s]|r" --Yellow function name. help pinpoint where the debug msg is from.
-----------------------------
local function Debug(from, ...)	--
-- simple print function.	--
------------------------------
	if DEBUG == false then
		return 
	end
	local tbl  = {...}
	local msg = tostring(tbl[1])
	for i=2,table_getn(tbl) do 
		msg = msg..strWhiteBar..tostring(tbl[i])
	end
	echo(strDebugFrom:format(from).." "..msg)
end
core.Debug = Debug

----------------------------------------------
function core:MySlashProcessorFunc(input)	--
-- /da function brings up the UI options.	--
----------------------------------------------
	InterfaceOptionsFrame_OpenToCategory(coreOpts)
	echo("MySlashProcessorFunc")
end

function core:ACTIONBAR_SLOT_CHANGED(event, ...)
--[[
	When changing talent trees, This will fire for every actionSlot, but they'll be nil.
	Then event will fire again with actionSlot 0, redo all our macro text then.
]]
	local actionSlot= ...
	if actionSlot == 0 then
		self:ResetAllMacroText()
	end
end

function core:SKILL_LINES_CHANGED(event, ...)
--~ 	Debug(event, ...)
	
	if not self.initialized then
		self:WorkTheBars()
	end
end

function core:PLAYER_REGEN_ENABLED(event, ...)
--~ 	Debug(event, ...)
	
	if InCombatLockdown() then
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		return
	end
	
	for actionSlot, value in pairs(self.UpdateActions) do 
--~ 		Debug(event, "InsecurelyUpdateAction", actionSlot)
		self.InsecurelyUpdateAction(actionSlot)
	end
	self.UpdateActions = {}
	
end

function core:PLAYER_ENTERING_WORLD(event, ...)
	if self.initialized == true then
		self:ResetAllMacroText()
	end
end


function core:ACTIVE_TALENT_GROUP_CHANGED(event, ...)
--~ 	Debug(event, self.initialized, ...)
--~ 	if self.initialized == true then
--~ 		self:ResetAllMacroText()
--~ 	end
end

function core:PARTY_MEMBERS_CHANGED(event, ...)
	if self.initialized == true then
		self:ResetAllMacroText()
	end
end


function core:WorkTheBars()
	Debug("WorkTheBars", _G.Bartender4)
	if _G.Bartender4 then
		for i=1, 10 do 
			self:DoBT4Actions("BT4Bar"..i)
		end

--~ 	elseif _G.Dominos then
	else
		core:DoDefaultActions()
	end
	

	
--~ 	core.pickplacehooked=true
	
	for i=1,132 do
		core.InsecurelyUpdateAction(i)
	end
	self.initialized = true
end


function core:ResetAllMacroText()
	if InCombatLockdown() then
		for i=1,132 do
			core.UpdateActions[i] = true
		end
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
	else
		for i=1,132 do
			self.InsecurelyUpdateAction(i)
		end
	end
end

function core:buttonTest()--	/run _MA:buttonTest()
	local btn = GetMouseFocus()
	local actionType, spellID, subType = GetActionInfo(btn.action)
	
	local spellName = GetSpellName( spellID, BOOKTYPE_SPELL )
	
	Debug("A", btn.action, spellName, actionType, spellID, subType)
	
	Debug("B", btn.action, "Helpful:"..tostring(IsHelpfulSpell(spellID, BOOKTYPE_SPELL)), "Harmful:"..tostring(IsHarmfulSpell(spellID, BOOKTYPE_SPELL)), "Passive:"..tostring(IsPassiveSpell(spellID, BOOKTYPE_SPELL)))
	
	
	Debug("C", btn.action, btn:GetAttribute("type"))
	
	
	
	
	Debug("D", btn.action, SpellHasRange(spellID, BOOKTYPE_SPELL))
	
	Debug("E", GetSpellInfo(spellID, BOOKTYPE_SPELL))
	
--~ 	if btn:GetAttribute("type") == "click" then
--~ 		
--~ 	end
	Debug("F", core:GetSpellType(btn.action, spellID))
	
	
--~ 	local LOCAL_API_Frame = _G["SecureHandlersUpdateFrame"]
--~ 	
--~ 	local value = LOCAL_API_Frame:GetAttribute("_frame-" .. label, refFrame);
	
end

function core:GetSpellType(aID, sID)
--~ 	Debug("GetSpellType", aID, sID)
	
--~ 	local spellName = GetSpellInfo(sID)
--~ 	local spellName, spellRank = GetSpellName( sID, BOOKTYPE_SPELL )
--~ 	Debug("GetSpellType", sID, spellName, IsHelpfulSpell(sID, BOOKTYPE_SPELL))
	
	
	
	if not SpellHasRange(sID, BOOKTYPE_SPELL) then
		return "Passive"
	end
	
	if IsPassiveSpell(sID, BOOKTYPE_SPELL) then
		return "Passive"
	end
	
	local spellName, spellRank = GetSpellName( sID, BOOKTYPE_SPELL )
	if core.mouseTargeting[spellName] then
		return "Passive"
	end
	
	if IsHelpfulSpell(sID, BOOKTYPE_SPELL) then
--~ 		if core.channelSpells[spellName] then
--~ 			return "Beneficial-Channel"
--~ 		end
		return "Beneficial"
	end

--~ 	if core.channelSpells[spellName] then
--~ 		return "Harmful-Channel"
--~ 	end
	if IsHarmfulSpell(sID, BOOKTYPE_SPELL) then
		return "Harmful"
	end
	return "Passive"
end

----------------------------------------------------------------------------------
function core:DoBT4Actions(barName)												--
----------------------------------------------------------------------------------
	local bar = _G[barName]--"BT4Bar1"
	local button
	local getActionSlot
	if bar then
		local kids = { bar:GetChildren() }
		for i, child in ipairs(kids) do
			if child:GetName():find("Button") then
--~ 				Debug("DoBT4Actions", i, child, child and child.action)
			
				if barName == "BT4Bar1" then
					
					getActionSlot = [[local actionSlot = 12*(GetActionBarPage()-1)+]].. (i-1)
				else
					getActionSlot = [[local actionSlot = ]]..child.action
				end
				self:ModifyButton(child, getActionSlot)
			end
		end
	end
end

function core:FindTankID()
	local isTank, unitID
	for i=1, GetNumPartyMembers() do 
		unitID = "party"..i
		if UnitExists(unitID) then
			isTank = UnitGroupRolesAssigned(unitID);
			if isTank then
				return unitID
			end
		end
	end
	return nil
end

function core:FindHealerID()
	local isTank, isHealer, unitID
	for i=1, GetNumPartyMembers() do 
		unitID = "party"..i
		if UnitExists(unitID) then
			isTank, isHealer = UnitGroupRolesAssigned(unitID);
			if isHealer then
				return unitID
			end
		end
	end
	return nil
end

--------------------------------------------------------------
function core:DoDefaultActions()							--	/run _MA:DoDefaultActions()
-- Code copied from MacroTexter's InitBlizzBars function.	--
--------------------------------------------------------------

	local prefixes = {}
	prefixes[3] = "MultiBarRightButton"
	prefixes[4] = "MultiBarLeftButton"
	prefixes[5] = "MultiBarBottomRightButton"
	prefixes[6] = "MultiBarBottomLeftButton"
	local btn, kind, value, subtype, page
	
	local actionSlot = 0
	local getActionSlot

	for btnnum=1,NUM_ACTIONBAR_BUTTONS do
		--note to self, this needs to be in brackets to function correctly.
	
		getActionSlot = [[local actionSlot = 12*(GetActionBarPage()-1)+]]..btnnum

		--Normal bar
		self:ModifyButton(_G["ActionButton"..btnnum], getActionSlot, btnnum)
		
		--Bonus Bar
		self:ModifyButton(_G["BonusActionButton"..btnnum], [[
			local actionSlot
			local page = GetActionBarPage()
			if page==1 then
				actionSlot = 12*(GetBonusBarOffset()+5) --btnnum will be added at the end
			else
				actionSlot = 12*(page-1) --btnnum will be added at the end
			end
			actionSlot = actionSlot +
		]]..btnnum)
		
		--Other bars
		for page,pref in pairs(prefixes) do
			getActionSlot = [[local actionSlot = ]]..(12*(page-1)+btnnum)
			self:ModifyButton(getglobal(prefixes[page]..btnnum), getActionSlot, btnnum)
		end
	end
end

function core:ModifyButton(btn, getActionSlot, btnnum)

	--Set up the dynamic properties (tell it how to set attributes when clicked or dragged).
	SecureHandlerSetFrameRef(btn, "MA_headerFrame", MA_headerFrame)

	btn:SetAttribute("type", "click") --This is because pressing keybindings do not activate :Click().  This way, it clicks itself and modifies its action temporarily on each click.
	btn:SetAttribute("clickbutton", btn)
	
	--Wraping these handlers seems to limit our API access to only functions found in RestrictedEnvironment.lua
--~ 	SecureHandlerWrapScript(btn, "OnDragStart", MA_headerFrame, getActionSlot..core.mainActionButtonDragDropPre, core.mainActionButtonDragDropPost)
--~ 	SecureHandlerWrapScript(btn, "OnReceiveDrag", MA_headerFrame, getActionSlot..core.mainActionButtonDragDropPre, core.mainActionButtonDragDropPost)
	
	SecureHandlerWrapScript(btn, "PreClick", MA_headerFrame, getActionSlot..[[
		--Clicking with an action on the cursor while in combat messes things up.  Hopefully I'll find a way around this.
		local header = self:GetFrameRef("MA_headerFrame")
		local macrotext = header:GetAttribute("action"..actionSlot.."text")
--~ 		print("PreClick", actionSlot, macrotext)
		if macrotext then
			self:SetAttribute("type", "macro")
			self:SetAttribute("macrotext", macrotext)
		else
			self:SetAttribute("type", "action")
		end
		control:CallMethod("NoncombatClick", self:GetName(), actionSlot)
		
]])
	SecureHandlerWrapScript(btn, "PostClick", MA_headerFrame, [[self:SetAttribute("type", "click")]])

end

MA_headerFrame.NoncombatClick = function(_, btnname, actionSlot)
	if GetCursorInfo() then
		Debug("NoncombatClick", btnname, actionSlot)
		if InCombatLockdown() then
			print("There's a known bug: if you click to place an action during combat, it will either disappear or get placed without the appropriate macrotext.  You can fix this by dragging it off and putting it back on without releasing the mouse inbetween.")
			
		else
			getglobal(btnname):SetAttribute("type")
			PickupAction(actionSlot)
		end
	end
end


--~ core.mainActionButtonDragDropPre = [[
--~ 	print("mainActionButtonDragDropPre A", actionSlot, kind, value, ...)
--~ 	print("mainActionButtonDragDropPre B", "GetSpellName:"..tostring(GetSpellName), "GetActionInfo:"..tostring(GetActionInfo))
--~ 	control:RunAttribute("ActionPlaced", actionSlot, kind, value, ...)
--~ 	control:CallMethod("UnhookPickPlace")
--~ 	return "message", true --tell the Post snippet to be called
--~ ]]
--~ core.mainActionButtonDragDropPost = [[control:CallMethod("HookPickPlace")]] --This will be used later.


core.UpdateActions ={}


function core.InsecurelyUpdateAction(actionSlot)
	
--~ 	if not core.pickplacehooked then return end
	if InCombatLockdown() then
		echo("Action button changed while in combat? MA will update that action once you exit combat.")
		
		core:RegisterEvent("PLAYER_REGEN_ENABLED")
		core.UpdateActions[actionSlot] = true
		return 
	end
--~ 	local a1,a2,a3 = GetActionInfo(actionSlot)
	local actionType, spellID, subType = GetActionInfo(actionSlot)
	if actionType=="item" then
		_,subType = GetItemInfo(spellID)
	end

	--[[
	if actionSlot < 70 then
		if GetSpellName and actionType and actionType == "spell" and subType  == "spell" and spellID and spellID > 0 then
			local spellName, spellRank = GetSpellName( spellID, BOOKTYPE_SPELL )
			Debug("InsecurelyUpdateAction", actionSlot, "aT:"..tostring(actionType), "sID:"..tostring(spellID), "sT:"..tostring(subType), spellName, spellRank)
		else
			Debug("InsecurelyUpdateAction", actionSlot, "aT:"..tostring(actionType), "sID:"..tostring(spellID), "sT:"..tostring(subType))
		end
	end
	]]
	
	assert(loadstring([[local self=MA_headerFrame ]]..MA_headerFrame:GetAttribute("ActionPlaced")))(actionSlot, actionType, spellID, subType) --emulates control:RunAttribute("ActionPlaced", actionSlot, GetCursorInfo())
end

--~ function MA_headerFrame.HookPickPlace()
--~ 	core.pickplacehooked = true
--~ end
--~ function MA_headerFrame.UnhookPickPlace()
--~ 	core.pickplacehooked = false
--~ end


MA_headerFrame:SetAttribute("ActionPlaced", [[
	local actionSlot, actionType, spellID, subType = ...
--~ 	local actionType, spellID, subType = GetActionInfo(actionSlot)

--~ 	if actionSlot == 2 then
--~ 		print("ActionPlaced", "---------------------")
--~ 		print("ActionPlaced A", ...)
--~ 		print("ActionPlaced C", value and self:GetAttribute("spelltext-"..value))

		
		
--~ 		print("ActionPlaced D", self:GetAttribute("action"..actionSlot.."text"))
--~ 		print("ActionPlaced E", "GetSpellName:"..tostring(GetSpellName), "IsInLFGDungeon:"..tostring(IsInLFGDungeon), "_MA:"..tostring(_MA), "GetActionInfo:"..tostring(GetActionInfo))
		
		
--~ 		print("ActionPlaced F", this, getglobal, _G)
--~ 	end
	
	local macrotext
	if GetSpellName and actionType and actionType == "spell" and subType  == "spell" and spellID and spellID > 0 then
	
		local spellName, spellRank = GetSpellName( spellID, BOOKTYPE_SPELL )
		if spellName  then --and not spellNames[spellName]
--~ 			print("ActionPlaced ", actionSlot, spellName)
			
			
			local spellType = _MA:GetSpellType(actionSlot, spellID)
			
--~ 			if spellName == "Shadow Bolt" then print(spellName, "A", actionSlot, spellType) end
			
			local fullSpell = spellName --.. " ("..spellRank..")"
			
			if IsInLFGDungeon() then
				macrotext = _MA.db.profile.macroText[spellType.."-RD"] or _MA.db.profile.macroText[spellType] or "/cast "..spellName
			else
				macrotext = _MA.db.profile.macroText[spellType] or "/cast "..spellName
			end
--~ 			if spellName == "Shadow Bolt" then print(spellName, "B", macrotext) end
			
			if _MA.channelSpells[spellName] and not _MA.mouseTargeting[spellName] then
				macrotext = "/stopmacro [channeling]\n"..macrotext
			end
			
			while macrotext:find("SPELLNR") do
				macrotext = macrotext:gsub("SPELLN", spellName.."("..spellRank..")")
			end
			
			while macrotext:find("SPELLN") do
				macrotext = macrotext:gsub("SPELLN", spellName)
			end
			
			while macrotext:find("TANKID") do
				macrotext = macrotext:gsub("TANKID", _MA:FindTankID() or "player")
			end
			
			while macrotext:find("HEALERID") do
				macrotext = macrotext:gsub("HEALERID", _MA:FindHealerID() or "player")
			end
			
--~ 			if spellName == "Shadow Bolt" then print(spellName, "C", macrotext) end
			
		end
		
	end
	
--~ 	if macrotext then
--~ 		print("ActionPlaced", self, _MA, ..., actionType, subType, spellID, macrotext)
--~ 	end

	self:SetAttribute("action"..actionSlot.."text", macrotext) --may be nil, in which case the button will perform its natural action
]])